/*
 * Copyright (C) 2001 Michael Schmitt <schmitt@itm.mu-luebeck.de>
 *
 *    Institute for Telematics,
 *    Medical University of Luebeck,
 *    Ratzeburger Allee 160,
 *    23538 Luebeck,
 *    Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "ScopeAST.hpp"

ANTLR_BEGIN_NAMESPACE(antlr)

// ANTLR_USE_NAMESPACE(std)map< RefString, RefString > InfoAST::_filenames;


RefEnvAST  ScopeAST::getEnv() const
{
  return environment;
}


ScopeAST::ScopeAST() : InfoAST(), environment(RefEnvAST(new EnvAST))
{
}


ScopeAST::ScopeAST( RefToken t ) : InfoAST( t ), environment(RefEnvAST(new EnvAST))
{
}


ScopeAST::ScopeAST( RefEnvAST env ) : InfoAST(), environment(env)
{
}


/*
RefAST  ScopeAST::factory()
{
  return RefAST( new InfoAST );
}
*/

ANTLR_END_NAMESPACE
